﻿#if !defined(_TEST_ACTOR_H_)
#define _TEST_ACTOR_H_

#include "IwGeom.h"

#include "IwGameUtil.h"
#include "IwGameSprite.h"
#include "IwGameAnim.h"
#include "IwGameScene.h"
#include "IwGameActor.h"
#include "IwGameImage.h"
#include "IwGameXoml.h"


//
//
// TestActor - A test actor
//
//
class TestActor : public CIwGameActorImage
{
public:

protected:
	// Properties
public:
	// Properties end

	TestActor() : CIwGameActorImage() {}
	virtual			~TestActor();
	
	bool			Init(CIwGameImage* image, int width, int height);
	void			Reset();
	bool			Update(float dt);
	bool			UpdateVisual();
	void			ResolveCollisions();
	void			NotifyCollision(CIwGameActor* other);

	void			OnTapped(int x, int y);
	void			OnBeginTouch(int x, int y);
	void			OnEndTouch(int x, int y);

	// Implementation of IIwGameXomlClass interface
	bool			LoadFromXoml(IIwGameXomlResource* parent, bool load_children, CIwGameXmlNode* node);
};

//
//  TestActorCreator - Creates an instance of a TestPlayer object
//
class TestActorCreator : public IIwGameXomlClassCreator
{
public:
	TestActorCreator()
	{
		setClassName("testactor");
	}
	IIwGameXomlResource*	CreateInstance(IIwGameXomlResource* parent)	{ return new TestActor(); }
};

#endif // _TEST_ACTOR_H_
