// 
//
// IwGame - Cross Platform Multi-purpose Game Engine using the Marmalade SDK
//
// Developed by Matthew Hopwood of Pocketeers Limited - www.pocketeers.co.uk
//
// For updates, tutorials and more details check out my blog at www.drmop.com
//
// This code is provided free of charge and without any warranty whatsoever. The only restriction to its usage is that this header must remain intact and visible in all IwGame engine files.
// If you use this engine in your product, whilst it is not mandatory, a mention of the IwGame engine would be nice or a quick email to let us know where it is being used.
//
//

#include "IwGameXoml.h"
#include "IwGameUtil.h"
#include "IwGameString.h"
#include "IwGame.h"
#include "IwGameScene.h"
#include "IwGameActor.h"
#include "IwGameActorParticles.h"
#include "IwGameAnim.h"
#include "IwGameShapes.h"
#include "IwGameBox2d.h"
#include "IwGameCamera.h"
#include "IwGameStyles.h"
#include "IwGameTemplates.h"
#include "IwGameActions.h"
#include "IwGameFont.h"


unsigned int CIwGameXomlNames::Game_Hash					= CIwGameString::CalculateHash("game");
unsigned int CIwGameXomlNames::Scene_Hash					= CIwGameString::CalculateHash("scene");
unsigned int CIwGameXomlNames::Actor_Hash					= CIwGameString::CalculateHash("actor");
unsigned int CIwGameXomlNames::ActorImage_Hash				= CIwGameString::CalculateHash("actorimage");
unsigned int CIwGameXomlNames::ResourceGroup_Hash			= CIwGameString::CalculateHash("resourcegroup");
unsigned int CIwGameXomlNames::Animation_Hash				= CIwGameString::CalculateHash("animation");
unsigned int CIwGameXomlNames::Box2dMaterial_Hash			= CIwGameString::CalculateHash("box2dmaterial");
unsigned int CIwGameXomlNames::Shape_Hash					= CIwGameString::CalculateHash("shape");
unsigned int CIwGameXomlNames::Actions_Hash					= CIwGameString::CalculateHash("actions");
unsigned int CIwGameXomlNames::Camera_Hash					= CIwGameString::CalculateHash("camera");
unsigned int CIwGameXomlNames::Image_Hash					= CIwGameString::CalculateHash("image");
unsigned int CIwGameXomlNames::Font_Hash					= CIwGameString::CalculateHash("font");
unsigned int CIwGameXomlNames::Timeline_Hash				= CIwGameString::CalculateHash("timeline");
unsigned int CIwGameXomlNames::Style_Hash					= CIwGameString::CalculateHash("style");
unsigned int CIwGameXomlNames::Variable_Hash				= CIwGameString::CalculateHash("variable");

unsigned int CIwGameXomlNames::Count_Hash					= CIwGameString::CalculateHash("count");
unsigned int CIwGameXomlNames::Action_Hash					= CIwGameString::CalculateHash("action");
unsigned int CIwGameXomlNames::Name_Hash					= CIwGameString::CalculateHash("name");
unsigned int CIwGameXomlNames::File_Hash					= CIwGameString::CalculateHash("file");
unsigned int CIwGameXomlNames::Current_Hash					= CIwGameString::CalculateHash("current");
unsigned int CIwGameXomlNames::CanvasSize_Hash				= CIwGameString::CalculateHash("canvassize");
unsigned int CIwGameXomlNames::FixAspect_Hash				= CIwGameString::CalculateHash("fixaspect");
unsigned int CIwGameXomlNames::LockWidth_Hash				= CIwGameString::CalculateHash("lockwidth");
unsigned int CIwGameXomlNames::Extents_Hash					= CIwGameString::CalculateHash("extents");
unsigned int CIwGameXomlNames::AllowSuspend_Hash			= CIwGameString::CalculateHash("allowsuspend");
unsigned int CIwGameXomlNames::Clipping_Hash				= CIwGameString::CalculateHash("clipping");
unsigned int CIwGameXomlNames::Active_Hash					= CIwGameString::CalculateHash("active");
unsigned int CIwGameXomlNames::Visible_Hash					= CIwGameString::CalculateHash("visible");
unsigned int CIwGameXomlNames::Layers_Hash					= CIwGameString::CalculateHash("layers");
unsigned int CIwGameXomlNames::Colliders_Hash				= CIwGameString::CalculateHash("colliders");
unsigned int CIwGameXomlNames::Type_Hash					= CIwGameString::CalculateHash("type");
unsigned int CIwGameXomlNames::Position_Hash				= CIwGameString::CalculateHash("position");
unsigned int CIwGameXomlNames::Origin_Hash					= CIwGameString::CalculateHash("origin");
unsigned int CIwGameXomlNames::Velocity_Hash				= CIwGameString::CalculateHash("velocity");
unsigned int CIwGameXomlNames::VelocityDamping_Hash			= CIwGameString::CalculateHash("velocitydamping");
unsigned int CIwGameXomlNames::Angle_Hash					= CIwGameString::CalculateHash("angle");
unsigned int CIwGameXomlNames::AngularVelocity_Hash			= CIwGameString::CalculateHash("angularvelocity");
unsigned int CIwGameXomlNames::AngularVelocityDamping_Hash	= CIwGameString::CalculateHash("angularvelocitydamping");
unsigned int CIwGameXomlNames::Depth_Hash					= CIwGameString::CalculateHash("depth");
unsigned int CIwGameXomlNames::DepthVelocity_Hash			= CIwGameString::CalculateHash("depthvelocity");
unsigned int CIwGameXomlNames::DepthVelocityDamping_Hash	= CIwGameString::CalculateHash("depthvelocitydamping");
unsigned int CIwGameXomlNames::Scale_Hash					= CIwGameString::CalculateHash("scale");
unsigned int CIwGameXomlNames::ScaleX_Hash					= CIwGameString::CalculateHash("scalex");
unsigned int CIwGameXomlNames::ScaleY_Hash					= CIwGameString::CalculateHash("scaley");
unsigned int CIwGameXomlNames::ScaleVelocity_Hash			= CIwGameString::CalculateHash("scalevelocity");
unsigned int CIwGameXomlNames::ScaleVelocityDamping_Hash	= CIwGameString::CalculateHash("scalevelocitydamping");
unsigned int CIwGameXomlNames::Colour_Hash					= CIwGameString::CalculateHash("colour");
unsigned int CIwGameXomlNames::ColourVelocity_Hash			= CIwGameString::CalculateHash("colourvelocity");
unsigned int CIwGameXomlNames::ColourVelocityDamping_Hash	= CIwGameString::CalculateHash("colourvelocitydamping");
unsigned int CIwGameXomlNames::Color_Hash					= CIwGameString::CalculateHash("color");
unsigned int CIwGameXomlNames::Layer_Hash					= CIwGameString::CalculateHash("layer");
unsigned int CIwGameXomlNames::Collidable_Hash				= CIwGameString::CalculateHash("collidable");
unsigned int CIwGameXomlNames::CollisionSize_Hash			= CIwGameString::CalculateHash("collisionsize");
unsigned int CIwGameXomlNames::CollisionRect_Hash			= CIwGameString::CalculateHash("collisionrect");
unsigned int CIwGameXomlNames::WrapPosition_Hash			= CIwGameString::CalculateHash("wrapposition");
unsigned int CIwGameXomlNames::Size_Hash					= CIwGameString::CalculateHash("size");
unsigned int CIwGameXomlNames::Text_Hash					= CIwGameString::CalculateHash("text");
unsigned int CIwGameXomlNames::GroupFile_Hash				= CIwGameString::CalculateHash("groupfile");
unsigned int CIwGameXomlNames::Frame_Hash					= CIwGameString::CalculateHash("frame");
unsigned int CIwGameXomlNames::Value_Hash					= CIwGameString::CalculateHash("value");
unsigned int CIwGameXomlNames::Time_Hash					= CIwGameString::CalculateHash("time");
unsigned int CIwGameXomlNames::Repeat_Hash					= CIwGameString::CalculateHash("repeat");
unsigned int CIwGameXomlNames::Duration_Hash				= CIwGameString::CalculateHash("duration");
unsigned int CIwGameXomlNames::SpawnDelay_Hash				= CIwGameString::CalculateHash("spawndelay");
unsigned int CIwGameXomlNames::SrcRect_Hash					= CIwGameString::CalculateHash("srcrect");
unsigned int CIwGameXomlNames::Location_Hash				= CIwGameString::CalculateHash("location");
unsigned int CIwGameXomlNames::Resource_Hash				= CIwGameString::CalculateHash("resource");
unsigned int CIwGameXomlNames::Preload_Hash					= CIwGameString::CalculateHash("preload");
unsigned int CIwGameXomlNames::Blocking_Hash				= CIwGameString::CalculateHash("blocking");
unsigned int CIwGameXomlNames::AutoPlay_Hash				= CIwGameString::CalculateHash("autoplay");
unsigned int CIwGameXomlNames::Anim_Hash					= CIwGameString::CalculateHash("anim");
unsigned int CIwGameXomlNames::StartAtTime_Hash				= CIwGameString::CalculateHash("startattime");
unsigned int CIwGameXomlNames::Delta_Hash					= CIwGameString::CalculateHash("delta");
unsigned int CIwGameXomlNames::Interpolate_Hash				= CIwGameString::CalculateHash("interpolate");
unsigned int CIwGameXomlNames::Easing_Hash					= CIwGameString::CalculateHash("easing");
unsigned int CIwGameXomlNames::Target_Hash					= CIwGameString::CalculateHash("target");
unsigned int CIwGameXomlNames::Width_Hash					= CIwGameString::CalculateHash("width");
unsigned int CIwGameXomlNames::Height_Hash					= CIwGameString::CalculateHash("height");
unsigned int CIwGameXomlNames::Radius_Hash					= CIwGameString::CalculateHash("radius");
unsigned int CIwGameXomlNames::Points_Hash					= CIwGameString::CalculateHash("points");
unsigned int CIwGameXomlNames::Point_Hash					= CIwGameString::CalculateHash("point");
unsigned int CIwGameXomlNames::Particle_Hash				= CIwGameString::CalculateHash("particle");
unsigned int CIwGameXomlNames::Data_Hash					= CIwGameString::CalculateHash("data");
unsigned int CIwGameXomlNames::Density_Hash					= CIwGameString::CalculateHash("density");
unsigned int CIwGameXomlNames::Friction_Hash				= CIwGameString::CalculateHash("friction");
unsigned int CIwGameXomlNames::Restitution_Hash				= CIwGameString::CalculateHash("restitution");
unsigned int CIwGameXomlNames::COM_Hash						= CIwGameString::CalculateHash("com");
unsigned int CIwGameXomlNames::Gravity_Hash					= CIwGameString::CalculateHash("gravity");
unsigned int CIwGameXomlNames::Mode_Hash					= CIwGameString::CalculateHash("mode");
unsigned int CIwGameXomlNames::WorldScale_Hash				= CIwGameString::CalculateHash("worldscale");
unsigned int CIwGameXomlNames::Sensor_Hash					= CIwGameString::CalculateHash("sensor");
unsigned int CIwGameXomlNames::CollisionFlags_Hash			= CIwGameString::CalculateHash("collisionflags");
unsigned int CIwGameXomlNames::Set_Hash						= CIwGameString::CalculateHash("set");
unsigned int CIwGameXomlNames::Property_Hash				= CIwGameString::CalculateHash("property");
unsigned int CIwGameXomlNames::HitTest_Hash					= CIwGameString::CalculateHash("hittest");
unsigned int CIwGameXomlNames::FlipX_Hash					= CIwGameString::CalculateHash("flipx");
unsigned int CIwGameXomlNames::FlipY_Hash					= CIwGameString::CalculateHash("flipy");
unsigned int CIwGameXomlNames::LinkedTo_Hash				= CIwGameString::CalculateHash("linkedto");
unsigned int CIwGameXomlNames::Template_Hash				= CIwGameString::CalculateHash("template");
unsigned int CIwGameXomlNames::Prefix_Hash					= CIwGameString::CalculateHash("prefix");
unsigned int CIwGameXomlNames::AlignH_Hash					= CIwGameString::CalculateHash("alignh");
unsigned int CIwGameXomlNames::AlignV_Hash					= CIwGameString::CalculateHash("alignv");
unsigned int CIwGameXomlNames::Wrap_Hash					= CIwGameString::CalculateHash("wrap");
unsigned int CIwGameXomlNames::Italic_Hash					= CIwGameString::CalculateHash("italic");
unsigned int CIwGameXomlNames::Underline_Hash				= CIwGameString::CalculateHash("underline");
unsigned int CIwGameXomlNames::Method_Hash					= CIwGameString::CalculateHash("method");
unsigned int CIwGameXomlNames::Param1_Hash					= CIwGameString::CalculateHash("param1");
unsigned int CIwGameXomlNames::Param2_Hash					= CIwGameString::CalculateHash("param2");
unsigned int CIwGameXomlNames::Batch_Hash					= CIwGameString::CalculateHash("batch");
unsigned int CIwGameXomlNames::AllowFocus_Hash				= CIwGameString::CalculateHash("allowfocus");
unsigned int CIwGameXomlNames::TouchPanX_Hash				= CIwGameString::CalculateHash("touchpanx");
unsigned int CIwGameXomlNames::TouchPanY_Hash				= CIwGameString::CalculateHash("touchpany");

unsigned int CIwGameXomlNames::OnTapped_Hash				= CIwGameString::CalculateHash("ontapped");
unsigned int CIwGameXomlNames::OnBeginTouch_Hash			= CIwGameString::CalculateHash("onbegintouch");
unsigned int CIwGameXomlNames::OnEndTouch_Hash				= CIwGameString::CalculateHash("onendtouch");
unsigned int CIwGameXomlNames::OnSuspend_Hash				= CIwGameString::CalculateHash("onsuspend");
unsigned int CIwGameXomlNames::OnResume_Hash				= CIwGameString::CalculateHash("onresume");
unsigned int CIwGameXomlNames::OnLostFocus_Hash				= CIwGameString::CalculateHash("onlostfocus");
unsigned int CIwGameXomlNames::OnGainedFocus_Hash			= CIwGameString::CalculateHash("ongainedfocus");
unsigned int CIwGameXomlNames::OnStart_Hash					= CIwGameString::CalculateHash("onstart");
unsigned int CIwGameXomlNames::OnEnd_Hash					= CIwGameString::CalculateHash("onend");
unsigned int CIwGameXomlNames::OnRepeat_Hash				= CIwGameString::CalculateHash("onrepeat");
unsigned int CIwGameXomlNames::OnCreate_Hash				= CIwGameString::CalculateHash("oncreate");
unsigned int CIwGameXomlNames::OnDestroy_Hash				= CIwGameString::CalculateHash("ondestroy");

unsigned int CIwGameXomlNames::ChangeScene_Hash				= CIwGameString::CalculateHash("changescene");
unsigned int CIwGameXomlNames::SuspendScene_Hash			= CIwGameString::CalculateHash("suspendscene");
unsigned int CIwGameXomlNames::ResumeScene_Hash				= CIwGameString::CalculateHash("resumescene");
unsigned int CIwGameXomlNames::ShowScene_Hash				= CIwGameString::CalculateHash("showscene");
unsigned int CIwGameXomlNames::HideScene_Hash				= CIwGameString::CalculateHash("hidescene");
unsigned int CIwGameXomlNames::ActivateScene_Hash			= CIwGameString::CalculateHash("activatescene");
unsigned int CIwGameXomlNames::DeactivateScene_Hash			= CIwGameString::CalculateHash("deactivatescene");
unsigned int CIwGameXomlNames::KillScene_Hash				= CIwGameString::CalculateHash("killscene");
unsigned int CIwGameXomlNames::ShowActor_Hash				= CIwGameString::CalculateHash("showactor");
unsigned int CIwGameXomlNames::HideActor_Hash				= CIwGameString::CalculateHash("hideactor");
unsigned int CIwGameXomlNames::ActivateActor_Hash			= CIwGameString::CalculateHash("activateactor");
unsigned int CIwGameXomlNames::DeactivateActor_Hash			= CIwGameString::CalculateHash("deactivateactor");
unsigned int CIwGameXomlNames::KillActor_Hash				= CIwGameString::CalculateHash("killactor");
unsigned int CIwGameXomlNames::PlayTimeline_Hash			= CIwGameString::CalculateHash("playtimeline");
unsigned int CIwGameXomlNames::StopTimeline_Hash			= CIwGameString::CalculateHash("stoptimeline");
unsigned int CIwGameXomlNames::SetTimeline_Hash				= CIwGameString::CalculateHash("settimeline");
unsigned int CIwGameXomlNames::PlaySound_Hash				= CIwGameString::CalculateHash("playsound");
unsigned int CIwGameXomlNames::PlayMusic_Hash				= CIwGameString::CalculateHash("playmusic");
unsigned int CIwGameXomlNames::SetVar_Hash					= CIwGameString::CalculateHash("setvar");

unsigned int CIwGameXomlNames::bool_Hash					= CIwGameString::CalculateHash("bool");
unsigned int CIwGameXomlNames::float_Hash					= CIwGameString::CalculateHash("float");
unsigned int CIwGameXomlNames::int_Hash						= CIwGameString::CalculateHash("int");
unsigned int CIwGameXomlNames::vec2_Hash					= CIwGameString::CalculateHash("vec2");
unsigned int CIwGameXomlNames::vec3_Hash					= CIwGameString::CalculateHash("vec3");
unsigned int CIwGameXomlNames::vec4_Hash					= CIwGameString::CalculateHash("vec4");
unsigned int CIwGameXomlNames::rect_Hash					= CIwGameString::CalculateHash("rect");
unsigned int CIwGameXomlNames::string_Hash					= CIwGameString::CalculateHash("string");
unsigned int CIwGameXomlNames::box_Hash						= CIwGameString::CalculateHash("box");
unsigned int CIwGameXomlNames::circle_Hash					= CIwGameString::CalculateHash("circle");
unsigned int CIwGameXomlNames::polygon_Hash					= CIwGameString::CalculateHash("polygon");
unsigned int CIwGameXomlNames::static_Hash					= CIwGameString::CalculateHash("static");
unsigned int CIwGameXomlNames::dynamic_Hash					= CIwGameString::CalculateHash("dynamic");
unsigned int CIwGameXomlNames::kinematic_Hash				= CIwGameString::CalculateHash("kinematic");
unsigned int CIwGameXomlNames::Linear_Hash					= CIwGameString::CalculateHash("linear");
unsigned int CIwGameXomlNames::QuadIn_Hash					= CIwGameString::CalculateHash("quadin");
unsigned int CIwGameXomlNames::QuadOut_Hash					= CIwGameString::CalculateHash("quadout");
unsigned int CIwGameXomlNames::CubicIn_Hash					= CIwGameString::CalculateHash("cubicin");
unsigned int CIwGameXomlNames::CubicOut_Hash				= CIwGameString::CalculateHash("cubicout");
unsigned int CIwGameXomlNames::QuarticIn_Hash				= CIwGameString::CalculateHash("quarticin");
unsigned int CIwGameXomlNames::QuarticOut_Hash				= CIwGameString::CalculateHash("quarticout");
unsigned int CIwGameXomlNames::left_Hash					= CIwGameString::CalculateHash("left");
unsigned int CIwGameXomlNames::right_Hash					= CIwGameString::CalculateHash("right");
unsigned int CIwGameXomlNames::centre_Hash					= CIwGameString::CalculateHash("centre");
unsigned int CIwGameXomlNames::top_Hash						= CIwGameString::CalculateHash("top");
unsigned int CIwGameXomlNames::middle_Hash					= CIwGameString::CalculateHash("middle");
unsigned int CIwGameXomlNames::bottom_Hash					= CIwGameString::CalculateHash("bottom");


//
//
//
//
// CIwGameXomlResourceManager implementation
//
//
//
//
/*void CIwGameXomlResourceManager::addResource(const char* resource_name, const char* resource_filename, bool preload)
{
	IIwGameXomlResource* resource = new CIwGameResourceResource();
	resource->setResourceName(resource_name);
	resource->setResourceFilename(resource_filename);
	Resources.push_back(resource);

	if (preload)
	{
		resource->Load();
	}
}*/

void CIwGameXomlResourceManager::addResource(IIwGameXomlResource *resource)
{
	Resources.push_back(resource);
	resource->setManaged(true);
}

void CIwGameXomlResourceManager::removeResource(IIwGameXomlResource* resource)
{
	removeResource(resource->getNameHash(), resource->getClassTypeHash());
}

void CIwGameXomlResourceManager::removeResource(unsigned int name_hash, unsigned int type_hash)
{
	// Renove named image from the manager
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash() && type_hash == (*it)->getClassTypeHash())
		{
			delete *it;
			Resources.erase(it);
			break;
		}
	}
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(unsigned int name_hash, unsigned int type_hash, bool global_search)
{
	// Find and return named image of specific type
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash() && type_hash == (*it)->getClassTypeHash())
			return *it;
	}

	if (global_search)
	{
		// Not found so check global resources
		CIwGameXomlResourceManager* m = IW_GAME_GLOBAL_RESOURCES->getResourceManager();
		if (m != this)	// Prevent global resource manager from calling itself
			return m->findResource(name_hash, type_hash, false);
	}

	return NULL;
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(const char* name, unsigned int type_hash, bool global_search)
{
	return findResource(CIwGameString::CalculateHash(name), type_hash, global_search);
}

IIwGameXomlResource* CIwGameXomlResourceManager::findResource(const char* name, const char* type, bool global_search)
{
	return findResource(CIwGameString::CalculateHash(name), CIwGameString::CalculateHash(type), global_search);
}


void CIwGameXomlResourceManager::clearResources()
{
	// Remove and delete all images from the manager
	for (_Iterator it = Resources.begin(); it != Resources.end(); ++it)
	{
		delete *it;
	}
	Resources.clear();
}


//
// 
// 
//
// CIwGameXoml Implementation
// 
// 
// 
//
CDECLARE_SINGLETON(CIwGameXoml)

void CIwGameXoml::Init()
{
	// Add some basic classes to the XOML engine
	addClass(new CIwGameCreator());					// CIwGame object
	addClass(new CIwGameResourceGroupCreator());	// CIwGameResourceGroup object 
	addClass(new CIwGameSceneCreator());			// CIwGameScene object 
	addClass(new CIwGameAnimCreator());				// CIwGameAnim object 
	addClass(new CIwGameImageCreator());			// CIwGameImage object 
	addClass(new CIwGameAnimTimelineCreator());		// CIwGameAnimTimeline object 
	addClass(new CIwGameShapeCreator());			// CIwGameShape object 
	addClass(new CIwGameCameraCreator());			// CIwGameCamera object 
	addClass(new CIwGameStyleCreator());			// CIwGameStyle object 
	addClass(new CIwGameXomlAddVariableCreator());	// CIwGameXomlAddVariable object 
#if defined(IW_GAME_BOX2D)
	addClass(new CIwGameBox2dMaterialCreator());	// CIwGameBox2dMaterial object 
#endif // IW_GAME_BOX2D_H_
	addClass(new CIwGameActionsCreator());			// CIwGameActions object 
	addClass(new CIwGameXomlLoadCreator());			// CIwGameXomlLoad object 
	addClass(new CIwGameTemplateCreator());			// CIwGameTemplate object 
	addClass(new CIwGameTemplateFromCreator());		// CIwGameTemplateFrom object 
	addClass(new CIwGameFontCreator());				// CIwGameFont object 
	addClass(new CIwGameActorTextCreator());		// CIwGameActorText object
	addClass(new CIwGameActorParticlesCreator());	// CIwGameActorParticles object

	// Add scene actions
	for (int t = 0; t < CIwGameXomlAction_Scenes::Action_Max; t++)
		addAction(new CIwGameXomlAction_Scenes((CIwGameXomlAction_Scenes::ActionType)t));
	// Add actor actions
	for (int t = 0; t < CIwGameXomlAction_Actors::Action_Max; t++)
		addAction(new CIwGameXomlAction_Actors((CIwGameXomlAction_Actors::ActionType)t));
	// Add global actions
	for (int t = 0; t < CIwGameXomlAction_Global::Action_Max; t++)
		addAction(new CIwGameXomlAction_Global((CIwGameXomlAction_Global::ActionType)t));

}

void CIwGameXoml::Release()
{
	// Clean up actions
	for (_ActionsIterator it = actions_begin(); it != actions_end(); ++it)
	{
		delete *it;
	}
	Actions.clear();

	// Clean up class creators
	for (_Iterator it = begin(); it != end(); ++it)
	{
		delete *it;
	}
	ClassCreators.clear();
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, const char* filename, bool reset_xml_pools)
{
	if (reset_xml_pools)
		CIwGameXmlParser::PoolsReset();
	CIwGameXmlParser*	xml = new CIwGameXmlParser();

	// Load and parse the xml file
	if (xml->Parse(filename) == eXMLParserError_None)
	{
		// Process the XOML data
		bool error = Process(parent, xml->GetRoot()->GetFirstNode());
		delete xml;
		return error;
	}

	delete xml;
	return false;
}

bool CIwGameXoml::Process(IIwGameXomlResource* parent, CIwGameXmlNode* node, CIwGameString* prefix)
{
	node->ToLower(true);

	for (CIwGameXmlNode::_Iterator it = node->begin(); it != node->end(); it++)
	{
		unsigned int name_hash = (*it)->GetName().getHash();

		// Check to see if we support the class
		for (_Iterator it2 = begin(); it2 != end(); ++it2)
		{
			if ((*it2)->getClassNameHash() == name_hash)
			{
				// We do support the class so call the classes creator to instantiate it
				IIwGameXomlResource* instance = (*it2)->CreateInstance(parent);
				if (instance != NULL)
				{
					// Set prefix in case we were called from template
					instance->SetPrefix(prefix);

					// Load up from XOML
					if (!instance->LoadFromXoml(parent, true, *it))
					{
						CIwGameError::LogError("Error: Near XOML tag ", (*it)->GetName().c_str());
						return false;
					}
				}
				else
				{
					CIwGameError::LogError("Error: No XOML creator present for ", (*it)->GetName().c_str());
					return false;
				}
				break;
			}
		}
	}

	return true;
}

void CIwGameXoml::ApplyStyle(CIwGameStyle* style, CIwGameXmlNode* node)
{
	// Add style properties to nodes
	for (CIwGameStyle::_Iterator it = style->begin(); it != style->end(); ++it)
	{
		node->AddAttribute((*it)->Name, (*it)->Value);
	}
}

// 
// 
//
//
// CIwGameXomlVariableManager implementation
//
//
//
//

void CIwGameXomlVariableManager::addVariable(CIwGameXomlVariable* variable)
{
	Variables.push_back(variable);
}

void CIwGameXomlVariableManager::addVariable(const char* name, eCIwGameXomlVariableType type)
{
	CIwGameXomlVariable* var = findVariable(CIwGameString::CalculateHash(name));
	if (var == NULL)
	{
		Variables.push_back(CreateVariable(name, type));
	}
}

void CIwGameXomlVariableManager::addVariable(const char* name, eCIwGameXomlVariableType type, const char* value)
{
	CIwGameXomlVariable* var = findVariable(CIwGameString::CalculateHash(name));
	if (var == NULL)
	{
		CIwGameXomlVariable* v = CreateVariable(name, type);
		v->setValue(value);
		Variables.push_back(v);
	}
}

void CIwGameXomlVariableManager::setVariable(unsigned int name_hash, const char* value)
{
	CIwGameXomlVariable* var = findVariable(name_hash);
	if (var != NULL)
	{
		var->setValue(value);
	}
}

void CIwGameXomlVariableManager::setVariable(const char* name, const char* value)
{
	setVariable(CIwGameString::CalculateHash(name), value);
}

CIwGameXomlVariable* CIwGameXomlVariableManager::findVariable(unsigned int name_hash)
{
	for (_Iterator it = Variables.begin(); it != Variables.end(); ++it)
	{
		if ((*it)->Name.getHash() == name_hash)
		{
			return *it;
		}
	}

	return NULL;
}

CIwGameXomlVariable* CIwGameXomlVariableManager::findVariable(const char* name)
{
	return findVariable(CIwGameString::CalculateHash(name));
}

void CIwGameXomlVariableManager::clearVariables()
{
	// Remove and delete all images from the manager
	for (_Iterator it = Variables.begin(); it != Variables.end(); ++it)
	{
		delete *it;
	}
	Variables.clear();
}

CIwGameXomlVariable* CIwGameXomlVariableManager::CreateVariable(const char* name, eCIwGameXomlVariableType type)
{
	// Create variable of specified type
	switch (type)
	{
		case VT_String: 
			{
				CIwGameXomlVariable* var = new CIwGameXomlVariable();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Bool: 
			{
				CIwGameXomlVariableBool* var = new CIwGameXomlVariableBool();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Float: 
			{
				CIwGameXomlVariableFloat* var = new CIwGameXomlVariableFloat();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Int: 
			{
				CIwGameXomlVariableInt* var = new CIwGameXomlVariableInt();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Vec2: 
			{
				CIwGameXomlVariableVec2* var = new CIwGameXomlVariableVec2();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Vec3: 
			{
				CIwGameXomlVariableVec3* var = new CIwGameXomlVariableVec3();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
		case VT_Vec4: 
			{
				CIwGameXomlVariableVec4* var = new CIwGameXomlVariableVec4();
				var->Name = name;
				var->Type = type;

				return var;
			}
			break;
	}

	return NULL;
}

//
// 
// 
//
// CIwGameXomlAddVariable Implementation
// 
// 
// 
//
bool CIwGameXomlAddVariable::LoadFromXoml(IIwGameXomlResource* parent, bool load_children, CIwGameXmlNode* node)
{
	CIwGameString name, value, type;

	// Process variable specific attributes
	for (CIwGameXmlNode::_AttribIterator it = node->attribs_begin(); it != node->attribs_end(); it++)
	{
		unsigned int name_hash = (*it)->getName().getHash();

		if (name_hash == CIwGameXomlNames::Name_Hash)
			name = (*it)->GetValue();
		else
		if (name_hash == CIwGameXomlNames::Value_Hash)
			value = (*it)->GetValue();
		else
		if (name_hash == CIwGameXomlNames::Type_Hash)
			type = (*it)->GetValue();
	}

	if (!name.IsEmpty())
	{
		// Determine type of variable
		eCIwGameXomlVariableType vtype = VT_String;
		if (!type.IsEmpty())
		{
			unsigned int type_hash = type.getHash();
			if (type_hash == CIwGameXomlNames::bool_Hash)
				vtype = VT_Bool;
			else
			if (type_hash == CIwGameXomlNames::float_Hash)
				vtype = VT_Float;
			else
			if (type_hash == CIwGameXomlNames::int_Hash)
				vtype = VT_Int;
			else
			if (type_hash == CIwGameXomlNames::vec2_Hash)
				vtype = VT_Vec2;
			else
			if (type_hash == CIwGameXomlNames::vec3_Hash)
				vtype = VT_Vec3;
			else
			if (type_hash == CIwGameXomlNames::vec4_Hash)
				vtype = VT_Vec4;
		}

		// If we are declared inside a scene then variable is local to the scene else global
		if (parent != NULL && parent->getClassTypeHash() == CIwGameXomlNames::Scene_Hash)
		{
			((CIwGameScene*)parent)->getVariableManager()->addVariable(name.c_str(), vtype, value.c_str());
		}
		else
		{
			IW_GAME_GLOBAL_RESOURCES->getVariableManager()->addVariable(name.c_str(), vtype, value.c_str());
		}
	}
	else
	{
		CIwGameError::LogError("Error: XOML - Variable must be named");
		delete this;
		return false;
	}

	delete this;

	return true;
}

//
// 
// 
//
// CIwGameXomlLoad Implementation
// 
// 
// 
//
bool CIwGameXomlLoad::LoadFromXoml(IIwGameXomlResource* parent, bool load_children, CIwGameXmlNode* node)
{
	// Process LoadXoml specific attributes
	for (CIwGameXmlNode::_AttribIterator it = node->attribs_begin(); it != node->attribs_end(); it++)
	{
		unsigned int name_hash = (*it)->getName().getHash();

		if (name_hash == CIwGameXomlNames::File_Hash)
		{
			IW_GAME_XOML->Process(parent, (*it)->GetValue().c_str(), false);
		}
	}
	delete this;

	return true;
}
